
/* DMAISA.C */

#include <dos.h>
#include <stdio.h>
#include <conio.h>
void main(void)
{
long int endereco;
int matriz[50],i;
unsigned char pagina, msb, lsb;

/* constri endereo a partir do seletor e do offset reservados */
endereco=(long int)FP_SEG(matriz)*16+(long int)FP_OFF(matriz);
/* escreve registrador de pgina e endereo base */
pagina= (unsigned char)((endereco>>16)&0xFF);
lsb= (unsigned char)((endereco>>1)&0xFF);
msb= (unsigned char)((endereco>>9)&0xFF);


outportb(0xD8,0);		/* apaga flip-flop apontador */
outportb(0x89,pagina);	/* programa endereo */
outportb(0xC8,lsb);
outportb(0xC8,msb);

outportb(0xD8,0);		/* apaga flip-flop apontador */
outportb(0xCA,49);	/* programa nmero de transferncias */
outportb(0xCA,0);	/* 49 + 1 transferncias */
outportb(0xD0,0);		/* registrador de comando */
outportb(0xD4,0x02);	/* habilita canal 6 */

/* programa leitura pelo canal 6, tranferncias por bloco,
		incremento de endereos e auto-inicicializao */
outportb(0xD6,0x96);

outportb(0x300,0);	/* strobe para transferncias */

printf("Tecle algo para imprimir matriz lida por DMA.\n");
getch( );		/* tempo para todas as 50 transferncias */
for (i=0;i<50;i++)	printf("%x\n",matriz[i]);
outportb(0xD4,0x06);	/* desabilita canal 6 */
}



