
/* ADCDAC.C */

#ifdef __cplusplus
	#define __CPPARGS ...
#else
	#define __CPPARGS
#endif

#include <dos.h>
#include <stdio.h>
#include <conio.h>

int base;

void interrupt (*rotinavelha)(__CPPARGS);

void interrupt rotina(__CPPARGS)
{
	outportb(base,inportb(base));		/* l A/D e escreve no D/A */
	outportb(0x20,0x20); 			/* libera 8259 mestre */
	outportb(0xA0,0x20); 			/* libera 8259 escravo */
}

void main(void)
{
	unsigned int Q,N;
	printf("Selecione o Endereo Base:\n");
	printf("Entre com o valor Q tal que endereo= 300h + 8*Q.\n");
	scanf("%d",&Q);
	Q=Q&0x0F;
	base=0x300+Q*8;			/* calcula endereo-base */
	printf("\nEndereo-base = %x.\n",base);
	printf("Entre com o valor N tal que taxa=8MHz/(N+1).\n");
	scanf("%d",&N);
	printf("\nTaxa = %ld.\n",(long)((long)8000*(long)1000/(N+1)));
	disable( );			/*desabilita as interrupes*/
	rotinavelha=getvect(0x71);     /*salva manipulador antigo da IRQ9*/
	setvect(0x71,rotina);	    /*instala a rotina do usurio p/ IRQ9*/
	outportb(0xA1,inportb(0xA1)&0xFD);		/*habilita a IRQ9*/
	outport(base+4,N);		/* atualiza taxa de amostragem */
	enable( );			/* habilita as interrupes*/
	while (!kbhit( ));		/* espera toque de tecla */
	while (kbhit( )) getch( );	/* zera buffer do teclado */
	disable( );			/* desabilita interrupes */
	outportb(0xA1,inportb(0xA1)|0x02);	/* desabilita a IRQ9*/
	setvect(0x71,rotinavelha);	/* restaura manipulador da IRQ9*/
	enable( );			/* habilita interrupes */
}

