/* IRQ5CONT.C */

#ifdef __cplusplus
	#define __CPPARGS ...
#else
	#define __CPPARGS
#endif

#include <dos.h>
#include <stdio.h>
#include <conio.h>

void interrupt (*rotinavelha)(__CPPARGS);

void interrupt rotina(__CPPARGS)
{
	printf("%d\r",(int)inport(0x300));		/* contador de 16 bits */
	outportb(0x20,0x20);			/* libera 8259 mestre */
}

void main(void)
{
int i;
disable( );			/*desabilita as interrupes*/
rotinavelha=getvect(0x0D);	/*salva manipulador da IRQ5*/
setvect(0x0D,rotina);		/*instala manipulador p/ IRQ5*/
outportb(0x21,inportb(0x21)&0xDF);	/*habilita a IRQ5*/
enable( );			/*habilita as interrupes*/
i=0;
while (i<10)
	  {
		getch( );			/* espera tecla ser pressionada*/
		outportb(0x300,0);		/* strobe para IRQ5 */
		i++; 
	  }
disable( );			/* desabilita interrupes */
outportb(0x21,inportb(0x21)|0x20);	/*desabilita a IRQ5*/
setvect(0x0D,rotinavelha);	/*restaura manipulador da IRQ5 */
enable( );			/* habilita interrupes */
}


